/*
 * Copyright (C) 2010 Guillaume Quintin.
 * This file is part of cct.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

int cct_write(terminal *t,int fd) {
  int i;
  buffer b;
  short oattr,attr;

  b.fd = fd;
  b.bp = 0;
  /* place cursor at upper left corner and reset all attributes */
  if ( _puts(&b,"\033[H\033[0m") == -1 ) return -1;
  /* draw the entire terminal except the last char */
  oattr = 0;
  for( i = 0 ; i < t->max - 1; i++ ) {
    attr = t->A[i];
    if ( _put_rune(&b,t->C[i],attr,oattr) == -1 ) return -1;
    oattr = attr;
  }
  /* disable line wrap */
  /* if ( _puts(&b,"\033[7l") == -1 ) return -1; */
  /* draw the last char */
  if ( _put_rune(&b,t->C[i],t->A[i],oattr) == -1 ) return -1;
  /* re-enable line wrap and reset all attributes */
  /* if ( _puts(&b,"\033[7h\033[0m") == -1 ) return -1; */
  if ( _puts(&b,"\033[0m") == -1 ) return -1;
  /* push all changes to the terminal */
  return _flush(&b);
}

int cct_refresh(terminal *t) {
  return cct_write(t,t->fd);
}

