/*
 * Copyright (C) 2010 Guillaume Quintin.
 * This file is part of cct.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <sys/select.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "cct.h"

terminal t;
cct_textbox box;

int main(void) {
  int c;
  if ( cct_init_term(&t,1) == -1 ) {
    fputs("initialization failed\n",stderr);
    return -1;
  }
  cct_textbox_init(&box,&t,1,1,10,0);
  cct_icanon_off(&t);
  cct_echo_off(&t);
  for(;;) {
    cct_clear(&t);
    cct_puts(&t,0,0,"type something: (exit for exiting)");
    cct_putc(&t,0,1,'>');
    cct_putc(&t,11,1,'<');
    cct_textbox_draw(&box);
    cct_refresh(&t);
    c = cct_get_key(cct_input(0));
    if ( c == '\n' ) {
      cct_icanon_on(&t);
      cct_echo_on(&t);
      cct_end_term(&t);
      printf("\ntext=%s\n",box.text);
      return 0;
    }
    cct_textbox_keypress(&box,c);
  }
  return 0;
}

/*
int x,y,dx,dy,l;

int main(void) {
  terminal t;
  fd_set rfds;
  struct timeval timeout;

  if ( cct_init_term(&t,1) == -1 ) {
    fputs("initialization failed\n",stderr);
    return -1;
  }

  l = t.w / 3;

  for(;;) {
    FD_ZERO(&rfds);
    FD_SET(0,&rfds);
    timeout.tv_sec = 0;
    timeout.tv_usec = 50000;
    if ( select(1,&rfds,0,0,&timeout) != -1 ) {
      if ( FD_ISSET(0,&rfds) ) return 0;
    }
    x += dx;
    y += dy;
    cct_clear(&t);
    cct_hline(&t,0,y,'-',t.w);
    cct_vline(&t,x,0,'|',t.h);
    t.attr = CCT_BOLD | CCT_REVERSE;
    cct_putc(&t,x,y,'X');
    t.attr = 0;
    cct_puts(&t,0,0,"cct by coincoin169");
    cct_col_left_puts(&t,0,3,
                 "test with several columns",
                 l);
    t.attr = CCT_REVERSE;
    cct_col_right_puts(&t,l,3,
                 "(right alignment here)",
                 l);
    t.attr = 0;
    cct_col_left_puts(&t,2*l,3,
                 "(left alignment here)",
                 t.w - 2 * l);
    cct_refresh(&t);
    if ( x >= t.w - 1 ) { x = t.w - 1; dx = -1; }
    if ( x <= 0 ) { x = 0; dx = 1; }
    if ( y >= t.h -1 ) { y = t.h - 1; dy = -1; }
    if ( y <= 0 ) { y = 0; dy = 1; }
  }

  return 0;
}
*/

