##
Copyright (C) 2012-2014  Guillaume Quintin.
This file is part of cocoju.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
##

==NAME==

cocoju - a console front-end for your favorite command-line audio
player

==SYNOPSIS==

`cocoju` [`-v`] [`-a`] [`-h`] [`-f`] [`homedir`]
[-- `player` `arg1` `arg2` ... [`%f`] ... `argn` ...]

==DESCRIPTION==

`cocoju` is a console front-end
for your favorite command-line audio player.
It allows you to play your music.
It is written in ANSI C and is POSIX.1 compliant.
Browse your audio and video files and play them, 
If you want to play all files in a directory and its sub-directories:
press the 'f' key to open the directory and all its sub-directories,
Enjoy...

==OPTIONS==

The base directory of `cocoju` is `homedir`.
If no directory is specified, `homedir` is the working directory.

> `-v`
  Just print the version of `cocoju` and then exit.

> `-a`
  Deactivate the autoplay mode when `cocoju` starts.
  See below for details about the autoplay mode.

> `-h`
  Show hidden files (files whose name begins with a ".").

> `-f`
  Open recursively all subdirectories of `homedir` and place all the
  files in the list to be displayed when `cocoju` starts.

> `--`
  If "--" is used then, instead of using `mplayer` by default,
  `cocoju` will call `player` with argument `arg1`, `arg2`, ... to
  play your files. If the arguments of `player` have to be passed in
  a given order, then you can tell `cocoju` at which position the
  filename should be using `%f`. For example, if you call `cocoju`
  with

  ``
  cocoju ~ -- cvlc %f --play-and-stop
  ``

  then, to play filename.ogg, `cocoju` will execute:

  ``
  cvlc filename.ogg --play-and-stop
  ``

  The `%f` is not mandatory. If it is not specified,
  then `cocoju` will add filename.ogg at the end:

  ``
  cvlc --play-and-stop filename.ogg
  ``

==MODES==

When not in `autoplay` mode, once a file has finished playing,
`cocoju` just stops and waits for the user. This is the default.
When in `autoplay` mode, once a file has finished playing,
the choice of the next file to be played follows these rules:
in `normal` mode, the next file is the following file in the same
list ; in `repeat` mode, the next file is the same file ;
in `shuffle` mode, the next file is a random file in the same list.

==GENERAL SHORTCUTS==

> `x`
  Stop playing music.

> `q`, `CTRL+D`
  Quit cocoju.

> `h`
  Go to `homedir`.

> `:dir`
  Go to directory `dir`.

> `a`
  Autoplay mode on/off.

> `s`
  Shuffle mode on/off.

> `r`
  Repeat mode on/off.

> `p`
  Pause/resume.

> `i`
  Highlight the currently playing file.

> `/pattern`
  Search forward in the list the next occurence of `pattern`.

> `n`
  Find the next occurence of `pattern`.

> `N`
  Find the previous occurence of `pattern`.

> `v`
  Play the next file, which depends on the chosen mode.
  See above for details.

> `=`
  On operating systems supporting the `SIGWINCH` signal like
  Linux, BSDs `cocoju` is resized automatically when
  the terminal's size is changed.
  But on other operating systems not supporting the `SIGWINCH`
  signal, if the terminal's size changes,
  the user can tell `cocoju` to fit into the new size by
  pressing '='.

> `u`
  Go to parent directory if any.

> `BACKSPACE`
  Go to previously opened list of files if any.

> `5`, `CTRL+R`
  Refresh the list.

> `f`
  When a directory is seleted, open recursively all its
  subdirectories and place all the files in a new list.

==AUTHOR==

cocoju and this man page were written by
Guillaume Quintin <coincoin169g@gmail.com>

