/*
 * Copyright (C) 2010-2014  Guillaume Quintin.
 * This file is part of cocoju.
 *
 * cocoju is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

void print_path_name(int x,int y,const char *s,int n) {
  int l,l1,l2;

  if ( n < 4 ) return;
  l = strlen(s);
  if ( l <= n ) {
    cct_puts(&G.term,x,y,s);
    return;
  }
  /* ../dir/file */
  for( l1 = l - 1 ; l1 >= 0 && s[l1] != '/' ; l1-- );
  for( l2 = l1 - 1 ; l2 >= 0 && s[l2] != '/' ; l2-- );
  cct_puts(&G.term,x,y,"..");
  if ( l - l2 + 1 <= n ) {
    cct_puts(&G.term,x + 2,y,&s[l2]);
    return;
  }
  if ( l - l1 + 1 <= n ) {
    cct_puts(&G.term,x + 2,y,&s[l1]);
    return;
  }
  cct_nputs(&G.term,x + 2,y,&s[l1],n);
}

void refresh_screen(void) {
  int y;
  y = G.height - 1;
  G.term.attr = 0;
  cct_clear(&G.term);
  if ( IS_VALID_PTR(G.curr) ) G.curr->output(G.curr);
  if ( IS_VALID_PTR(G.error) ) {
    G.term.attr = CCT_BOLD | CCT_REVERSE;
    cct_hline(&G.term,0,y,' ',G.width);
    cct_nputs(&G.term,0,y,G.error,G.width);
    goto refresh_screen_finish;
  }
  if ( G.editing ) {
    input_output();
  }
  else {
    G.term.attr = CCT_BOLD | CCT_REVERSE;
    cct_hline(&G.term,0,y,' ',G.width);
    if ( IS_VALID_PTR(G.curr) ) {
      print_path_name(0,y,G.curr->path,G.width - 9);
    }
    if ( G.repeat ) cct_putc(&G.term,G.width - 2,y,'r');
    if ( G.shuffle ) cct_putc(&G.term,G.width - 3,y,'s');
    if ( G.auto_play ) cct_putc(&G.term,G.width - 4,y,'a');
    if ( G.pausing ) cct_putc(&G.term,G.width - 5,y,'p');
  }
refresh_screen_finish:
  cct_refresh(&G.term);
}

void screen_resized(void) {
  if ( cct_resize(&G.term) == -1 ) end("cct cannot resize");
  G.width = G.term.w;
  G.height = G.term.h;
  G.list_height = G.height - 2;
  cct_textbox_resize(&G.txt,1,G.height - 1,G.width - 1);
  refresh_screen();
}

