/*
 * Copyright (C) 2010-2014  Guillaume Quintin.
 * This file is part of cocoju.
 *
 * cocoju is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

void parse_arguments(int argc,char **argv) {
  int i,j,k;
  if ( argc == 2 && !strcmp(argv[1],"-v") ) {
    puts(VERSION);
    exit(EXIT_SUCCESS);
  }
  G.base_dir = NULL;
  for( i = 1 ; i < argc ; ) {
    if ( argv[i][0] != '-' ) {
      G.base_dir = path_resolution(argv[i]);
      i++;
      continue;
    }
    if ( !strcmp(argv[i],"-f") ) {
      G.home_allinone = 1;
      i++;
      continue;
    }
    if ( !strcmp(argv[i],"-a") ) {
      G.auto_play = 1;
      i++;
      continue;
    }
    if ( !strcmp(argv[i],"-h") ) {
      G.show_hidden = 1;
      i++;
      continue;
    }
    if ( !strcmp(argv[i],"-v") ) {
      fputs(VERSION "\n",stdout);
      exit(EXIT_SUCCESS);
    }
    if ( !strcmp(argv[i],"--") ) {
      uma len,has_f;
      if ( i == argc - 1 ) end("no player given after '--'\n");
      len = argc - i + 1;
      G.player = malloc2(len * sizeof(char*));
      has_f = 0;
      for( j = i + 1,k = 0 ; j < argc ; j++,k++ ) {
        G.player[k] = argv[j];
        if ( !strcmp(argv[j],"%f") ) has_f = 1;
      }
      if ( has_f ) {
        G.player[k] = NULL;
      }
      else {
        G.player[k] = "%f";
        k++;
        G.player[k] = NULL;
      }
      goto parse_arguments_finish;
    }
    end("unknown option \"%s\"\n",argv[i]);
  }
parse_arguments_finish:
  if ( !G.base_dir ) G.base_dir = strdup2(getenv("PWD"));
  /*
  for( i = 0 ; G.player[i] ; i++ ) {
    fprintf(stdout,"argv[%d] = %s\n",i,G.player[i]);
  }
  exit(EXIT_FAILURE);
  */
}

