/*
 * Copyright (C) 2010-2014  Guillaume Quintin.
 * This file is part of cocoju.
 *
 * cocoju is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

struct random {
  uma last1,last2,last3;
} R;

void random_init(void) {
  R.last1 = -1;
  R.last2 = -1;
  R.last3 = -1;
  srand(time(0));
}

void random_push(uma i) {
  R.last3 = R.last2;
  R.last2 = R.last1;
  R.last1 = i;
}

uma random2(list *l) {
  uma i,j;
  if ( l->nf == 0 ) return -1;
  if ( l->nf == 1 ) return 0;
  if ( l->nf <= 3 ) {
    j = rand() % l->nf;
    if ( j == R.last1 ) j = (R.last1 + 1) % l->nf;
    R.last1 = j;
    return j;
  }
  for( i = 0 ; i < 6 ; i++ ) {
    j = rand() % l->nf;
    if ( j != R.last1 && j != R.last2 && j != R.last3 ) {
      random_push(j);
      return j;
    }
  }
  for( i = (R.last3 + 1) % l->nf ; i != R.last3 ; i = (i + 1) % l->nf ) {
    if ( i != R.last1 && i != R.last2 && i != R.last3 ) {
      random_push(i);
      return i;
    }
  }
  /* never to be reached*/
  random_push(0);
  return 0;
}

